// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb5.lib;

/**
 * Context
 */
public class Context {

	/**
	 * Initial ticket encryption types
	 */
	public int[] initialTicketETypes;

	/**
	 * TGS encryptions types
	 */
	public int[] tgsETypes;

	//public OSContext osContext;
	
	/**
	 * Default realm
	 */
	public Realm defaultRealm;

	//public Profile profile;
	//public DBContext dbContext;
	
	/**
	 * Sequence number
	 */
	public LocalSeqNumber seqNumber;

	/**
	 * Clock skew
	 */
	public long clockSkew;

	/**
	 * KDC request checksum type
	 */
	public int kdcReqCksumType;

	/**
	 * Default AP request checksum type
	 */
	public int defaultAPReqCksumType;

	/**
	 * Default KRB safe checksum type
	 */
	public int defaultKRBSafeCksumType;

	/**
	 * Default KDC options
	 */
	public KDCOptions defaultKDCOptions;
	//public LibraryOptions libraryOptions;
	//public boolean profileSecure;
	//public int fileCCacheDefaultFormat;
	//public int secureCCacheDefaultFormat;
}