// Copyright 1997 The Open Group Research Institute.  All rights reserved.
// Copyright 1999 Memesoft.  All rights reserved.

package krb5.lib.ccache;

import krb5.lib.*;

 //XXX save?
 /*public class foobar implements Cloneable extends CCacheInfo {
 * foobar(PrincipalName princName) {
 * super(PrincipalName);
 * }
 * public Object clone() {
 * return super.clone();
 * }
 * }
 */
 /**
  * Virtual memory credentials cache information
  */
public class VmCCacheInfo extends CCacheInfo implements Cloneable {

	/**
	 * Class constructor
	 *
	 * @param principalName is of type PrincipalName
	 * @see krb5.lib.PrincipalName
	 */
    public VmCCacheInfo(PrincipalName principalName) {
        super(principalName);
    }

	/**
	 * Clones a copy of the object
	 *
	 * @return Object is a result
	 */
    public Object clone() {
        return super.clone();
    }
}