// Copyright 1997 The Open Group Research Institute.  All rights reserved.
// Copyright 1999 Memesoft.  All rights reserved.

package krb5.lib.ccache;

import krb5.lib.*;

/**
 * Credential cache enumerator
 */
public interface CCacheEnumerator {

	/**
	 * Returns next credential
	 *
	 * @return Credentials is a result
	 * @see krb5.lib..ccache.Credentials
	 */
    Credentials nextCredential();

	/**
	 * Checks to see whether there are more credentials
	 *
	 * @return boolean is a result
	 */
    boolean hasMoreCredentials();
}