// Copyright 1998 The Open Group Research Institute.  All rights reserved.
// Copyright 1999 Memesoft.  All rights reserved.

package krb5.lib.ccache;

import krb5.lib.*;

class CCacheTestDriver {

    public static void main(String args[]) {
        try {

            CCacheFactory ccacheFactory = CCacheFactory.getFactory();

            CredentialsCache ccache = ccacheFactory.newCCacheInstance("VmCCacheImpl");

            ccache.setPrimaryPrincipal(new PrincipalName("sanfilip@MEMESOFT.COM"));

            CCacheEnumerator e = ccache.lookupCredentials(
                new CredentialsFilter[] {
                    new MatchPrincipalCredsFilter(ccache.getPrimaryPrincipal()),
                    new UnexpiredCredsFilter()
                }
            );

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

